# DCI examples

Repository for canonical [DCI](http://en.wikipedia.org/wiki/Data,_Context,_and_Interaction) code examples showing DCI solutions to a specific problem. 

Having multiple contributors coding the same example in different languages can help clarifying various aspect of the new paradigm. Discussions of the examples:

* [object-composition](http://groups.google.com/group/object-composition/topics?hl=en) - Tutorial discussions on DCI.
* [dci-evolution](http://groups.google.com/group/dci-evolution/topics?hl=en) - Forum for people to discuss, clarify, and evolve the paradigm (all can read - members can write).

If you want to share your DCI implementation of any of the examples with the community, send a message to marcgrue to get added as a contributor (write what programming language(s) you plan to use, then I can set you up).

Code is organized by example -> language -> contributor. So far we have the following examples and implementations:

## Money Transfer

The use case of transferring an amount from one account to another.

* **csharp**
   * [Christian Horsdal](https://github.com/DCI/dci-examples/tree/master/moneytransfer/csharp/christian-horsdal)
* **java**
   * [Ant Kutschera](https://github.com/DCI/dci-examples/tree/master/moneytransfer/java/ant-kutschera)
* **java-qi4j**
   * [Marc Grue](https://github.com/DCI/dci-examples/tree/master/moneytransfer/java-qi4j/marc-grue)
* **php**
   * [Risto Välimäki](https://github.com/DCI/dci-examples/tree/master/moneytransfer/php/risto-valimaki)


## Frontloading

Frontloading is a use case for computing the earliest start of every activity given the start of the project. The example is interesting in that the re-selection of objects is an essential part of the algorithm.   

* **java**
   * [Ant Kutschera](https://github.com/DCI/dci-examples/tree/master/frontloading/java/ant-kutschera)
* **java-qi4j**
   * [Marc Grue](https://github.com/DCI/dci-examples/tree/master/frontloading/java-qi4j/marc-grue)